#Copyright (c) 2006-2007 SunMedia technology (Chengdu) co. Ltd. 
#All right reserved
#Author:jin.hu
#date:2009/09/15

import struct

class ParserHeader:
    def __init__ (self, filePath):
        self.fp = open(filePath, 'r')
        self.fileHeaderData = self.fp.read()[0:28]
        self.fp.close()
        #self.kkk = open('E:\\test.c','w')
    	
    def getHeaderFlag (self):
        flag = struct.unpack_from(6*"s",self.fileHeaderData, 0)
        flagData = "".join(flag)
        flagIndex = -1
        if flagData == 'LOGO_0':
            flagIndex = 0
        elif flagData == 'DB_000':
        	flagIndex = 1
        elif flagData == 'UI_000':
            flagIndex = 2
        elif flagData == 'LOADER':
            flagIndex = 3
        elif flagData == 'APP_00':
            flagIndex = 4
        elif flagData == 'APP+_0':
            flagIndex = 5
        elif flagData == 'FONT_0':
            flagIndex = 6
        elif flagData == 'IP_3.0':
        	flagIndex = 7
        elif flagData == 'BROWER':
        	flagIndex = 8
        elif flagData == '??????':
            flagIndex = 9
        return flagIndex
    
    def getSW (self):
        SW = struct.unpack_from(4*"B", self.fileHeaderData, 6)
        a = SW[3] << 24
        b = SW[2] << 16
        c = SW[1] << 8
        d = SW[0]
        SWData = a + b + c + d
        return SWData
    def getTime (self):
        timeData  = struct.unpack_from(4*"B", self.fileHeaderData, 10)
        yearData = str((timeData[1] << 8)+(timeData[0]))
        monthData = str(timeData[2])
        dayData = str(timeData[3])
        return yearData+'.'+monthData+'.'+dayData
    def getLenth (self):
        lengthData = struct.unpack_from(4*"B", self.fileHeaderData, 20)
    	fileLength = (lengthData[3] << 24) + (lengthData[2] << 16) + (lengthData[1] << 8) + (lengthData[0])
    	return fileLength
    def getAdd (self):
    	addData = struct.unpack_from(4*"B", self.fileHeaderData, 14)
    	fileAdd = (addData[3] << 24) + (addData[2] << 16) + (addData[1] << 8) + (addData[0])
    	return fileAdd
    def getCRC (self):
        crcData = struct.unpack_from(4*"B", self.fileHeaderData, 24)
        fileCRC = (crcData[3] << 24) + (crcData[2] << 16) + (crcData[1] << 8) + (crcData[0])
    	#self.kkk.close()
        return fileCRC
    	
 
class GenerateHeader:
    def __init__ (self, filePath):
        self.fp = open(filePath, 'rb')
        self.haveHeader = 0
        self.defaultFileData = self.fp.read()
        self.fp.close()
        self.filePath = filePath

    def setHaveHeader (self, haveHeader):
    	self.haveHeader = haveHeader

    def generateFile(self, flag, sw, fileTime, addre, length, CRC):
        self.fp = open(self.filePath, 'wb')
        headerData = ''
        for i in range(6):
        	headerData += flag[i]
        headerData += chr(sw&0xff)
        headerData += chr(sw>>8&0xff)
        headerData += chr(sw>>16&0xff)
        headerData += chr(sw>>24&0xff)
        #kkk = open('E:\\test.c','wb')
        fileTimeList = fileTime.split('.')
        #kkk.write(str(fileTimeList))
        #kkk.close()
        headerData += chr(int(fileTimeList[0])&0xff)
        headerData += chr(int(fileTimeList[0])>>8&0xff)
        headerData += chr(int(fileTimeList[1])&0xff)
        headerData += chr(int(fileTimeList[2])&0xff)
        headerData += chr(addre&0xff)
        headerData += chr(addre>>8&0xff)
        headerData += chr(addre>>16&0xff)
        headerData += chr(addre>>24&0xff)
        headerData += chr(0)
        headerData += chr(0>>8&0xff)
        headerData += chr(length&0xff)
        headerData += chr(length>>8&0xff)
        headerData += chr(length>>16&0xff)
        headerData += chr(length>>24&0xff)
        headerData += chr(CRC&0xff)
        headerData += chr(CRC>>8&0xff)
        headerData += chr(CRC>>16&0xff)
        headerData += chr(CRC>>24&0xff)

        fileData = ''
        if self.haveHeader == 0:
            fileData = headerData + self.defaultFileData
        else:
            fileData = headerData + self.defaultFileData[28:]
        self.fp.write(fileData)
        self.fp.close()

class ParserType:
    def __init__ (self, filePath):
        self.filePath = filePath
        self.fileData = []

    def getFileData (self):
    	fp = open(self.filePath, 'r')
        self.fileData = fp.readlines()
        fp.close()
    
    def parseType (self):
        typeWidth = {}
    	for itemType in self.fileData:
            itemType = itemType.replace('\n', '')
            typeWidth[itemType[:itemType.find('-')]] = int(itemType[itemType.find('-')+1:])
        return typeWidth


def test1 ():
    c = ParserType('D:\\DVB Toolkit\\DVB Toolkit\\Bin\\data.type')
    c.getFileData()
    print c.parseType()
    

if __name__ == '__main__':
    test1()    		