#Copyright (c) 2006-2007 SunMedia technology (Chengdu) co. Ltd. 
#All right reserved
#Author:jin.hu
#date:2009/09/15

import time
import re
    
class ParserFile:
    def __init__(self, filePath):
        self.fp = open(filePath, 'r')
        self.fileData = []
        self.defaultIRData = 0
        self.isUartControl = 1


    def closeCFile(self):
        self.fp.close()

    def getFileData(self):
        self.fileData = self.fp.readlines()
        self.closeCFile()
    
    def getScriptData(self):
        #return self.fileData
        scriptData = []
        for scriptItem in self.fileData[1:]:
            scriptItemData = []
            index = 0
            if len(scriptItem.split(',')) != 4:
                continue
            for singleData in scriptItem.split(',')[1:4]:
                if index == 0:
                    scriptItemData.append(singleData)
                elif index == 1:
                    scriptItemData.append(singleData)
                elif index == 2:
                    scriptItemData.append(int(singleData))
                index += 1
            scriptData.append(scriptItemData)
        return scriptData
    
    def getToolType(self):
        if self.fileData[0] != 'UART\n':
            self.isUartControl = 0
            self.getIRVersion()
            return 0
        else:
            self.isUartControl = 1
            self.getIRVersion()
            return 1

    def getIRVersion(self):
        if self.isUartControl == 1:
            self.defaultIRData = 1
        else:
            if len(self.fileData[4].split(',')) == 6:
                self.defaultIRData = 0
            elif len(self.fileData[4].split(',')) == 9:
                self.defaultIRData = 1
            else:
                self.defaultIRData = -1
    
    def getIRModelType(self):
        return int(self.fileData[0])
    def getIRID(self):
        return int(self.fileData[2])
    def getIRCount(self):
        if self.isUartControl == 1:
            return int(self.fileData[4])
        else:
            return int(self.fileData[3])
    def getIRName(self, IRIndex):
        if self.isUartControl == 1:
            return self.fileData[5:][IRIndex].split(',')[0]
        else:
            return self.fileData[4:][IRIndex].split(',')[0]
    def getDigit(self, IRIndex):
        return int(self.fileData[5:][IRIndex].split(',')[1])
    def getIRKeyValue(self, IRIndex):
        return self.fileData[4:][IRIndex].split(',')[1]
    def getIRStart(self, IRIndex):
        keyValue = self.fileData[5:][IRIndex].split(',')[1]
        keyValue = keyValue.replace('{','',1).replace('}','',1).replace('\'','')
        keyValueList = keyValue.split(';')
        valueList = []
        for single in keyValueList:
            valueList.append(single.split(':'))
        return valueList[0:-1]
    def getUARTKeyValue(self, IRIndex):
        keyValue = self.fileData[5:][IRIndex].split(',')[2]
        keyValue = keyValue.replace('{','',1).replace('}','',1).replace('\'','')
        keyValueList = keyValue.split(';')
        valueList = []
        for single in keyValueList:
            valueList.append(single.split(':'))
        return valueList[0:-1]
    def getIREnd(self, IRIndex):
        keyValue = self.fileData[5:][IRIndex].split(',')[3]
        keyValue = keyValue.replace('{','',1).replace('}','',1).replace('\'','')
        keyValueList = keyValue.split(';')
        valueList = []
        for single in keyValueList:
            valueList.append(single.split(':'))
        return valueList[0:-1]

    def getIRAreaLeft(self, IRIndex):
        if self.isUartControl == 1:
            return int(self.fileData[5:][IRIndex].split(',')[4])
        else:
            return int(self.fileData[4:][IRIndex].split(',')[2])
    def getIRAreaTop(self, IRIndex):
        if self.isUartControl == 1:
            return int(self.fileData[5:][IRIndex].split(',')[5])
        else:
            return int(self.fileData[4:][IRIndex].split(',')[3])
    def getIRAreaRight(self, IRIndex):
        if self.isUartControl == 1:
            return int(self.fileData[5:][IRIndex].split(',')[6]) + int(self.fileData[5:][IRIndex].split(',')[4])
        else:
            return int(self.fileData[4:][IRIndex].split(',')[4]) + int(self.fileData[4:][IRIndex].split(',')[2])
    def getIRAreaBottom(self, IRIndex):
        if self.isUartControl == 1:
            return int(self.fileData[5:][IRIndex].split(',')[7])+int(self.fileData[5:][IRIndex].split(',')[5])
        else:
            return int(self.fileData[4:][IRIndex].split(',')[5])+int(self.fileData[4:][IRIndex].split(',')[3])
    def getIRBgColor(self, IRIndex):
        if self.defaultIRData == 1:
            if self.isUartControl == 1:
                return int(self.fileData[5:][IRIndex].split(',')[9])
            else:
                return int(self.fileData[4:][IRIndex].split(',')[7])
        else:
            return 0x808080
    def getIRFgColor(self, IRIndex):
        if self.defaultIRData == 1:
            if self.isUartControl == 1:
                return int(self.fileData[5:][IRIndex].split(',')[10])
            else:
                return int(self.fileData[4:][IRIndex].split(',')[8])
        else:
            return 0
    def getIRType(self, IRIndex):
        if self.defaultIRData == 1:
            if self.isUartControl == 1:
                return (self.fileData[5:][IRIndex].split(',')[8])
            else:
                return (self.fileData[4:][IRIndex].split(',')[6])
        else:
            return 'Button'
    def getItemData(self, IRIndex):
        itemData = self.fileData[5:][IRIndex].split(',')[1]
        itemData = itemData.replace('[','',1).replace(']','',1).replace('\'','')
        return itemData.split(';')

class ExportFile:
    def __init__(self):
        self.property = {}
        self.isUARTControl = 0
        self.controlData = ''
        self.fp = 0
        self.filePath = ''
    
    def formatButtonData(self, buttonData, buttonDataType):
        formatData = []
        for i in range(len(buttonDataType)):
            if buttonDataType[i] == 'Char' or buttonDataType[i] == 'ControlID':
                for j in range(len(buttonData[i])):
                    formatData.append(buttonData[i][j])
            elif buttonDataType[i] == 'Int':
                formatData.append(int(buttonData[i]))
        return formatData

    
    def createFile(self, filePath):
        self.filePath = filePath
        self.fp = open(filePath, 'w')
    def closeFile(self):
        self.fp.close()
    def addProperty(self, key, keyValue):
        self.property[key] = keyValue

    def writeScriptCount(self, scriptCount):
        self.fp.write(str(scriptCount))

    def writeScript(self, keyData):
        self.fp.write('\n')
        nIndex = 0
        for keyValue in keyData:
            if nIndex == (len(keyData)-1):
                self.fp.write(str(keyValue))
            else:
                self.fp.write(str(keyValue)+',')
            nIndex += 1
    
    def writeToolType(self):
        self.fp.write('UART'+'\n')
    def writeIRType(self, IRType):
        self.fp.write(str(IRType)+'\n')
    def writeIRID(self, IRID):
        self.fp.write('IR\n')
        self.fp.write(str(IRID)+'\n')
    def writeIRCount(self, IRCount):
        self.fp.write(str(IRCount)+'\n')
    
    def getIR(self):
        controlData = str(self.property['Name']) + ','
        controlData += str(self.property['KeyValue']) + ','
        controlData += str(self.property['Left']) + ','
        controlData += str(self.property['Top']) + ','
        controlData += str(self.property['Width']) + ','
        controlData += str(self.property['Height']) + ','
        controlData += str(self.property['ControlType']) + ','
        controlData += str(self.property['BGColor']) + ','
        controlData += str(self.property['FGColor']) + '\n'
        return controlData
    def writeIR(self):
        self.fp.write(self.getIR())
    
    def getUARTButton(self):
        controlData = str(self.property['Name']) + ','
        keyValue = '{'
        for i in range(len(self.property['StartType'])):
            keyValue += self.property['StartType'][i]+':'
            keyValue += self.property['StartValue'][i]+';'
        controlData += (keyValue + '},')
        keyValue = '{'
        for i in range(len(self.property['KeyValueType'])):
            keyValue += self.property['KeyValueType'][i]+':'
            keyValue += self.property['KeyValue'][i]+';'
        controlData += (keyValue + '},')
        keyValue = '{'
        for i in range(len(self.property['EndType'])):
            keyValue += self.property['EndType'][i]+':'
            keyValue += self.property['EndValue'][i]+';'
        controlData += (keyValue + '},')
        controlData += str(self.property['Left']) + ','
        controlData += str(self.property['Top']) + ','
        controlData += str(self.property['Width']) + ','
        controlData += str(self.property['Height']) + ','
        controlData += str(self.property['ControlType']) + ','
        controlData += str(self.property['BGColor']) + ','
        controlData += str(self.property['FGColor']) + '\n'
        return controlData
    def writeUARTButton(self):
        self.fp.write(self.getUARTButton())
    
    def getEditIR(self):
        controlData = str(self.property['Name']) + ','
        controlData += str(self.property['IsDigit']) + ','
        controlData += str(0) + ','
        controlData += str(0) + ','
        controlData += str(self.property['Left']) + ','
        controlData += str(self.property['Top']) + ','
        controlData += str(self.property['Width']) + ','
        controlData += str(self.property['Height']) + ','
        controlData += str(self.property['ControlType']) + ','
        controlData += str(0) + ','
        controlData += str(0) + '\n'
        return controlData
    def writeEditIR(self):
        self.fp.write(self.getEditIR())
    
    def getComboxIR(self):
        controlData = str(self.property['Name']) + ','
        itemData = str(self.property['ItemData'])
        itemData = itemData.replace(',', ';').replace(' ','')
        controlData += itemData + ','
        controlData += str(0) + ','
        controlData += str(0) + ','
        controlData += str(self.property['Left']) + ','
        controlData += str(self.property['Top']) + ','
        controlData += str(self.property['Width']) + ','
        controlData += str(self.property['Height']) + ','
        controlData += str(self.property['ControlType']) + ','
        controlData += str(0) + ','
        controlData += str(0) + '\n'
        return controlData
    def writeComboxIR(self):
        self.fp.write(self.getComboxIR())
    
    def getGroupIR(self):
        controlData = str(self.property['Name']) + ','
        controlData += str(0) + ','
        controlData += str(0) + ','
        controlData += str(0) + ','
        controlData += str(self.property['Left']) + ','
        controlData += str(self.property['Top']) + ','
        controlData += str(self.property['Width']) + ','
        controlData += str(self.property['Height']) + ','
        controlData += str(self.property['ControlType']) + ','
        controlData += str(self.property['BGColor']) + ','
        controlData += str(self.property['FGColor']) + '\n'
        return controlData
    def writeGroupIR(self):
        self.fp.write(self.getGroupIR())
    
    def getControl(self):
        self.closeFile()
        fpTemp = open(self.filePath, 'r')
        controlData = fpTemp.read()
        fpTemp.close()
        try:
            os.remove(self.filePath)
        except  WindowsError:
            pass
        return controlData

class ParserControl:
    def __init__(self, controlData):
        self.control = controlData.split('\n')
        
    def setToolType(self, isUARTControl):
        self.isUartControl = isUARTControl
    def getIRCount(self):
        return len(self.control) - 1
        #return 1
    def getIRName(self, IRIndex):
        return self.control[IRIndex].split(',')[0]
    def getDigit(self, IRIndex):
        return int(self.control[IRIndex].split(',')[1])
    def getIRKeyValue(self, IRIndex):
        return self.control[IRIndex].split(',')[1]
    def getIRStart(self, IRIndex):
        keyValue = self.control[IRIndex].split(',')[1]
        keyValue = keyValue.replace('{','',1).replace('}','',1).replace('\'','')
        keyValueList = keyValue.split(';')
        valueList = []
        for single in keyValueList:
            valueList.append(single.split(':'))
        return valueList[0:-1]
    def getUARTKeyValue(self, IRIndex):
        keyValue = self.control[IRIndex].split(',')[2]
        keyValue = keyValue.replace('{','',1).replace('}','',1).replace('\'','')
        keyValueList = keyValue.split(';')
        valueList = []
        for single in keyValueList:
            valueList.append(single.split(':'))
        return valueList[0:-1]
    def getIREnd(self, IRIndex):
        keyValue = self.control[IRIndex].split(',')[3]
        keyValue = keyValue.replace('{','',1).replace('}','',1).replace('\'','')
        keyValueList = keyValue.split(';')
        valueList = []
        for single in keyValueList:
            valueList.append(single.split(':'))
        return valueList[0:-1]

    def getIRAreaLeft(self, IRIndex):
        if self.isUartControl == 1:
            return int(self.control[IRIndex].split(',')[4])
        else:
            return int(self.control[IRIndex].split(',')[2])
    def getIRAreaTop(self, IRIndex):
        if self.isUartControl == 1:
            return int(self.control[IRIndex].split(',')[5])
        else:
            return int(self.control[IRIndex].split(',')[3])
    def getIRAreaRight(self, IRIndex):
        if self.isUartControl == 1:
            return int(self.control[IRIndex].split(',')[6]) + int(self.control[IRIndex].split(',')[4])
        else:
            return int(self.control[IRIndex].split(',')[4]) + int(self.control[IRIndex].split(',')[2])
    def getIRAreaBottom(self, IRIndex):
        if self.isUartControl == 1:
            return int(self.control[IRIndex].split(',')[7])+int(self.control[IRIndex].split(',')[5])
        else:
            return int(self.control[IRIndex].split(',')[5])+int(self.control[IRIndex].split(',')[3])
    def getIRBgColor(self, IRIndex):
        if self.isUartControl == 1:
            return int(self.control[IRIndex].split(',')[9])
        else:
            return int(self.control[IRIndex].split(',')[7])
    def getIRFgColor(self, IRIndex):
        if self.isUartControl == 1:
            return int(self.control[IRIndex].split(',')[10])
        else:
            return int(self.control[IRIndex].split(',')[8])
    def getIRType(self, IRIndex):
        if self.isUartControl == 1:
            return (self.control[IRIndex].split(',')[8])
        else:
            return (self.control[IRIndex].split(',')[6])
    def getItemData(self, IRIndex):
        itemData = self.control[IRIndex].split(',')[1]
        itemData = itemData.replace('[','',1).replace(']','',1).replace('\'','')
        return itemData.split(';') 


class ParserMacFile:
    def __init__(self, filePath):
        self.fp = open(filePath, 'r')
        self.macFileData = self.fp.readlines()
        self.fp.close()


    def getUpgradMac (self):
    	#if len(self.macFileData) != 2:
            #return []
        #upgradMacValue = self.macFileData[1].split(',')
        return self.macFileData
    	
class ExportMacFile:
    def __init__(self, filePath):
        filePath = filePath.lower()
        indexFlag = filePath.find('.txt')
        if indexFlag != -1:
            filePath = filePath[0:indexFlag]
        
        filePathUpgrade = filePath + '.txt'
        filePathUpgraded = filePath + '_upgraded.txt'
        self.fp = open(filePathUpgrade, 'w')
        self.fp1 = open(filePathUpgraded, 'w')

    def writeUpgradedValue (self, upgradedValue):
        for value in upgradedValue:
            self.fp1.write(value + '\n')
        self.fp1.close()
    def writeUpgradValue (self, upgradValue):
        for value in upgradValue:
            self.fp.write(value + '\n')
        self.fp.close()
        	
 
def test1 ():
    c = ParserFile('E:\\DVB Tool Integration\\IRC_Tool\\IRC_Tool\\IR\\uart.txt')
    c.getFileData()
    kkkkk = 'RRRR'
    BBBBB = kkkkk.lower()
    print kkkkk
    print BBBBB
    print c.getToolType()
    print c.defaultIRData
    IRcount = c.getIRCount()
    for i in range(IRcount):
        #print c.getIRKey(i)
        #print c.getIRKeyValue(i)
        print c.getIRAreaBottom(i)
    

if __name__ == '__main__':
    test1()